/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.compress;

import java.util.*;
import palmbible.parser.*;

public class CompressFilteredNode
{
	protected String value;
	protected int count;
	protected int size;
	protected CompressFilteredNode leftNode;
	protected CompressFilteredNode rightNode;

	public CompressFilteredNode(String value, int count) throws Exception
	{
		this.value = value;
		this.count = count;
		this.size = value.length() * (count - 1);
	}
	
	public void putNode(CompressFilteredNode node)
	{
		if (size == node.size){
			if (value.length() < node.value.length()){
				if (leftNode == null){
					leftNode = node;
				} else {
					leftNode.putNode(node);
				}
			} else {
				if (rightNode == null){
					rightNode = node;
				} else {
					rightNode.putNode(node);
				}
			}
		} else if (size < node.size){
			if (leftNode == null){
				leftNode = node;
			} else {
				leftNode.putNode(node);
			}
		} else {
			if (rightNode == null){
				rightNode = node;
			} else {
				rightNode.putNode(node);
			}
		}
	}

	public void fillVector(Vector vector, Map indexMap, int max)
	{
		if (leftNode != null){
			leftNode.fillVector(vector, indexMap, max);
		}

		if (vector.size() < max && count > 2){
		
			vector.addElement(value);
			indexMap.put(value, new Integer(vector.size()));
			
			if (rightNode != null){
				rightNode.fillVector(vector, indexMap, max);
			}
		}
	}
}
