package palmbible.gui;

import java.awt.*;
import javax.swing.*;

public class MainFrame extends JFrame {
    public MainFrame() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        mainMenuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        convertMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();
        toolBar = new javax.swing.JToolBar();
        openButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        saveAsButton = new javax.swing.JButton();
        convertButton = new javax.swing.JButton();
        bookListPanel = new javax.swing.JPanel();
        bookListTable = new javax.swing.JTable();
        optionPanel = new javax.swing.JPanel();
        optionBorderPanel = new javax.swing.JPanel();
        optionArrangePanel = new javax.swing.JPanel();
        outputInfoPanel = new javax.swing.JPanel();
        verNameLabel = new javax.swing.JLabel();
        verNameField = new javax.swing.JTextField();
        dbNameLabel = new javax.swing.JLabel();
        dbNameField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        convertOptionPanel = new javax.swing.JPanel();
        noTitleCheck = new javax.swing.JCheckBox();
        noBookCheck = new javax.swing.JCheckBox();
        convertFormatPanel = new javax.swing.JPanel();
        pdbCheck = new javax.swing.JCheckBox();
        htmlCheck = new javax.swing.JCheckBox();
        plainCheck = new javax.swing.JCheckBox();
        rtfCheck = new javax.swing.JCheckBox();
        thmlCheck = new javax.swing.JCheckBox();
        
        mainMenuBar.setFont(new java.awt.Font("Dialog", 0, 11));
        fileMenu.setText("File");
        fileMenu.setFont(mainMenuBar.getFont());
        openMenuItem.setFont(mainMenuBar.getFont());
        openMenuItem.setText("Open");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });
        
        fileMenu.add(openMenuItem);
        saveMenuItem.setFont(mainMenuBar.getFont());
        saveMenuItem.setText("Save");
        saveMenuItem.setEnabled(false);
        fileMenu.add(saveMenuItem);
        saveAsMenuItem.setFont(mainMenuBar.getFont());
        saveAsMenuItem.setText("Save As");
        saveAsMenuItem.setEnabled(false);
        fileMenu.add(saveAsMenuItem);
        convertMenuItem.setFont(openMenuItem.getFont());
        convertMenuItem.setText("Convert ...");
        convertMenuItem.setEnabled(false);
        fileMenu.add(convertMenuItem);
        exitMenuItem.setFont(mainMenuBar.getFont());
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        
        fileMenu.add(exitMenuItem);
        mainMenuBar.add(fileMenu);
        helpMenu.setText("Help");
        helpMenu.setFont(mainMenuBar.getFont());
        aboutMenuItem.setFont(mainMenuBar.getFont());
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        
        helpMenu.add(aboutMenuItem);
        mainMenuBar.add(helpMenu);
        
        setTitle("Bible Converter");
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        setName("main");
        setIconImage(new javax.swing.ImageIcon(getClass().getResource("/graphic/icon/BibleConverter.gif")).getImage());
        setFont(new java.awt.Font("Dialog", 0, 11));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        toolBar.setFloatable(false);
        toolBar.setMinimumSize(new java.awt.Dimension(50, 20));
        toolBar.setFont(mainMenuBar.getFont());
        toolBar.setMaximumSize(new java.awt.Dimension(300, 50));
        openButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/graphic/icon/Open16.gif")));
        openButton.setToolTipText("Open Source Text");
        openButton.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(4, 4, 4, 4)));
        openButton.setRequestFocusEnabled(false);
        toolBar.add(openButton);
        
        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/graphic/icon/Save16.gif")));
        saveButton.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(4, 4, 4, 4)));
        saveButton.setRequestFocusEnabled(false);
        toolBar.add(saveButton);
        
        saveAsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/graphic/icon/SaveAs16.gif")));
        saveAsButton.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(4, 4, 4, 4)));
        saveAsButton.setRequestFocusEnabled(false);
        toolBar.add(saveAsButton);
        
        convertButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/graphic/icon/Convert16.gif")));
        convertButton.setToolTipText("Generate File");
        convertButton.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(4, 4, 4, 4)));
        convertButton.setRequestFocusEnabled(false);
        toolBar.add(convertButton);
        
        getContentPane().add(toolBar, java.awt.BorderLayout.NORTH);
        
        bookListPanel.setLayout(new java.awt.BorderLayout());
        
        bookListTable.setBorder(new javax.swing.border.EtchedBorder());
        bookListTable.setModel(new javax.swing.table.DefaultTableModel(
        new Object [][] {
            {new Boolean(true), new Integer(10), "Genesis", "Genesis", "Gen"}
        },
        new String [] {
            "Select", "Number", "Book", "Name", "Shortcut"
        }
        ) {
            Class[] types = new Class [] {
                java.lang.Boolean.class, java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                true, false, false, true, true
            };
            
            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
            
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        bookListTable.setIntercellSpacing(new java.awt.Dimension(2, 2));
        bookListTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        bookListPanel.add(bookListTable, java.awt.BorderLayout.CENTER);
        
        getContentPane().add(bookListPanel, java.awt.BorderLayout.CENTER);
        
        optionPanel.setLayout(new java.awt.BorderLayout());
        
        optionBorderPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 3, 3));
        
        optionArrangePanel.setLayout(new javax.swing.BoxLayout(optionArrangePanel, javax.swing.BoxLayout.Y_AXIS));
        
        outputInfoPanel.setLayout(new java.awt.GridLayout(4, 2, 3, 2));
        
        outputInfoPanel.setBorder(new javax.swing.border.TitledBorder(null, "Source Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, mainMenuBar.getFont()));
        verNameLabel.setText("Version Name");
        verNameLabel.setFont(mainMenuBar.getFont());
        outputInfoPanel.add(verNameLabel);
        
        verNameField.setFont(mainMenuBar.getFont());
        verNameField.setPreferredSize(new java.awt.Dimension(60, 21));
        verNameField.setMaximumSize(new java.awt.Dimension(60, 2147483647));
        verNameField.setMinimumSize(new java.awt.Dimension(60, 21));
        outputInfoPanel.add(verNameField);
        
        dbNameLabel.setText("Source Encoding");
        dbNameLabel.setFont(mainMenuBar.getFont());
        outputInfoPanel.add(dbNameLabel);
        
        dbNameField.setFont(mainMenuBar.getFont());
        dbNameField.setPreferredSize(new java.awt.Dimension(60, 21));
        dbNameField.setMaximumSize(new java.awt.Dimension(60, 2147483647));
        dbNameField.setMinimumSize(new java.awt.Dimension(60, 21));
        outputInfoPanel.add(dbNameField);
        
        jLabel1.setText("Target Encoding");
        jLabel1.setFont(mainMenuBar.getFont());
        outputInfoPanel.add(jLabel1);
        
        jTextField1.setFont(mainMenuBar.getFont());
        jTextField1.setPreferredSize(new java.awt.Dimension(60, 21));
        jTextField1.setMaximumSize(new java.awt.Dimension(60, 2147483647));
        jTextField1.setMinimumSize(new java.awt.Dimension(60, 21));
        outputInfoPanel.add(jTextField1);
        
        optionArrangePanel.add(outputInfoPanel);
        
        convertOptionPanel.setLayout(new java.awt.GridLayout(3, 1));
        
        convertOptionPanel.setBorder(new javax.swing.border.TitledBorder(null, "Convert Option", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, mainMenuBar.getFont()));
        noTitleCheck.setFont(mainMenuBar.getFont());
        noTitleCheck.setText("No Titles");
        convertOptionPanel.add(noTitleCheck);
        
        noBookCheck.setFont(mainMenuBar.getFont());
        noBookCheck.setText("No Beginning Book Text");
        convertOptionPanel.add(noBookCheck);
        
        optionArrangePanel.add(convertOptionPanel);
        
        convertFormatPanel.setLayout(new java.awt.GridLayout(6, 1));
        
        convertFormatPanel.setBorder(new javax.swing.border.TitledBorder(null, "Convert Format", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, mainMenuBar.getFont()));
        pdbCheck.setSelected(true);
        pdbCheck.setFont(mainMenuBar.getFont());
        pdbCheck.setText("Palm PDB");
        convertFormatPanel.add(pdbCheck);
        
        htmlCheck.setFont(mainMenuBar.getFont());
        htmlCheck.setText("HTML");
        convertFormatPanel.add(htmlCheck);
        
        plainCheck.setFont(mainMenuBar.getFont());
        plainCheck.setText("Plain Text");
        convertFormatPanel.add(plainCheck);
        
        rtfCheck.setFont(mainMenuBar.getFont());
        rtfCheck.setText("Rich Text Format");
        convertFormatPanel.add(rtfCheck);
        
        thmlCheck.setFont(mainMenuBar.getFont());
        thmlCheck.setText("THML");
        convertFormatPanel.add(thmlCheck);
        
        optionArrangePanel.add(convertFormatPanel);
        
        optionBorderPanel.add(optionArrangePanel);
        
        optionPanel.add(optionBorderPanel, java.awt.BorderLayout.CENTER);
        
        getContentPane().add(optionPanel, java.awt.BorderLayout.EAST);
        
        setJMenuBar(mainMenuBar);
        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(720, 540));
        setLocation((screenSize.width-720)/2,(screenSize.height-540)/2);
    }//GEN-END:initComponents

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        AboutDialog aboutDialog = new AboutDialog(this, true);
        aboutDialog.show();
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
        FileDialog fileDialog = new FileDialog(this);
        fileDialog.show();
    }//GEN-LAST:event_openMenuItemActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        try {
            UIManager.setLookAndFeel(
                UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) { }


        MainFrame mainFrame = new MainFrame();
        mainFrame.show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar mainMenuBar;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem convertMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JToolBar toolBar;
    private javax.swing.JButton openButton;
    private javax.swing.JButton saveButton;
    private javax.swing.JButton saveAsButton;
    private javax.swing.JButton convertButton;
    private javax.swing.JPanel bookListPanel;
    private javax.swing.JTable bookListTable;
    private javax.swing.JPanel optionPanel;
    private javax.swing.JPanel optionBorderPanel;
    private javax.swing.JPanel optionArrangePanel;
    private javax.swing.JPanel outputInfoPanel;
    private javax.swing.JLabel verNameLabel;
    private javax.swing.JTextField verNameField;
    private javax.swing.JLabel dbNameLabel;
    private javax.swing.JTextField dbNameField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JPanel convertOptionPanel;
    private javax.swing.JCheckBox noTitleCheck;
    private javax.swing.JCheckBox noBookCheck;
    private javax.swing.JPanel convertFormatPanel;
    private javax.swing.JCheckBox pdbCheck;
    private javax.swing.JCheckBox htmlCheck;
    private javax.swing.JCheckBox plainCheck;
    private javax.swing.JCheckBox rtfCheck;
    private javax.swing.JCheckBox thmlCheck;
    // End of variables declaration//GEN-END:variables
}
