/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.pdbfile;

import palmbible.util.*;

public abstract class PDBRecord
{
	public static final byte SECRET_RECORD_BIT = (byte)16;
	public static final byte BUSY_BIT          = (byte)32;
	public static final byte DIRTY_BIT         = (byte)64;
	public static final byte DEL_ON_HSYNC_BIT  = (byte)128;
	
	public ByteBuffer content = new ByteBuffer();
	public byte attr = 0;

	public PDBRecord()
	{
		super();
	}

	public int size()
	{
		return content.size();
	}

	public void setAttributes(byte attr)
	{
		this.attr = attr;
	}

	public byte getAttributes()
	{
		return attr;
	}

	public ByteBuffer getBytes()
	{
		return content;
	}

	public void setBytes(ByteBuffer content)
	{
		this.content = content;
	}
}
