/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.util;

public class ShortShifter
{
	protected boolean byteShifted = false;
	protected int shift = 0;
	protected int lastShort = 0;
	
	public ShortShifter(boolean byteShifted)
	{
		this.byteShifted = byteShifted;
	}
	
	public int getShort(int input)
	{
		if (byteShifted){
			int result = 0;
			
			input = input & 0x3FFF;
			switch (shift) {
				case 0:
					result = -1;
					break;
				case 1:
					result = lastShort << 2 | input >> 12;
					break;
				case 2:
					result = lastShort << 4 | input >> 10;
					break;
				case 3:
					result = lastShort << 6 | input >>  8;
					break;
				case 4:
					result = lastShort << 8 | input >>  6;
					break;
				case 5:
					result = lastShort << 10 | input >> 4;
					break;
				case 6:
					result = lastShort << 12 | input >> 2;
					break;
				case 7:
					result = lastShort << 14 | input;
					break;
			}
	
			shift++;
			if (shift > 7){
				shift = 0;
			}
			
			lastShort = input;
	
			if (result !=-1){
				result = result & 0xFFFF;
			}
	
			return result;
		} else {
			return input;
		}
	}
	
	public int flush()
	{
		if (byteShifted){
			return getShort(0);
		} else {
			return -1;
		}
	}
}
