/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"

static Boolean cbxPenDowned;
static UInt16 cbxColorBox;

void CbxInitColorBox(ColorBoxPtr colorBoxPtr, UInt16 objID, 
	IndexedColorType color)
{
	UInt16 objIndex;
	IndexedColorType orgColorIndex;

	if (os35){
		colorBoxPtr->objID = objID;
		colorBoxPtr->color = color;

		objIndex = FrmGetObjectIndex(modalForm, objID);
		FrmGetObjectBounds(modalForm, objIndex, &colorBoxPtr->bound);

		WinDrawRectangleFrame(simpleFrame, &colorBoxPtr->bound);
		orgColorIndex = WinSetForeColor(color);
		WinDrawRectangle(&colorBoxPtr->bound, 0);
		WinSetForeColor(orgColorIndex);
	}
}

void CbxSetColorBox(ColorBoxPtr colorBoxPtr, IndexedColorType color)
{
	IndexedColorType orgColorIndex;

	if (os35){
		colorBoxPtr->color = color;
	
		orgColorIndex = WinSetForeColor(color);
		WinDrawRectangle(&colorBoxPtr->bound, 0);
		WinSetForeColor(orgColorIndex);
	}
}

Boolean CbxReleaseColorBox(ColorBoxPtr colorBoxPtr, EventPtr event)
{
	if (os35){
		if (cbxPenDowned && cbxColorBox == colorBoxPtr->objID){

			WinInvertRectangle(&colorBoxPtr->bound, 0);
			cbxPenDowned = false;

			if (RctPtInRectangle(event->screenX, 
				event->screenY, &colorBoxPtr->bound)){
				return true;
			}
		}
	}
	
	return false;
}

void CbxHitColorBox(ColorBoxPtr colorBoxPtr, EventPtr event)
{
	if (os35){
		if (!cbxPenDowned && RctPtInRectangle(event->screenX, event->screenY, 
			&colorBoxPtr->bound)) {
			WinInvertRectangle(&colorBoxPtr->bound, 0);

			cbxColorBox = colorBoxPtr->objID;
			cbxPenDowned = true;
		}
	}
}

void CbxReset()
{
	if (os35){
		cbxPenDowned = false;
		cbxColorBox = 0;
	}
}

Boolean CbxIsSet()
{
	if (os35){
		return (cbxColorBox != 0);
	} else {
		return false;
	}
}

