/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"
#include "PalmBible_res.h"   

static SECT1 FormPtr lastForm;
static SECT1 ColorBoxPtr colorBox;

static void closeForm()
{
	modalForm = lastForm;
	MemPtrFree(colorBox);
}

static SECT1 Boolean frmSelectColor_cmdClose_OnSelect(EventPtr event)
{
	closeForm();
	FrmReturnToForm(frmPref);

	return true;
}

static SECT1 Boolean frmSelectColor_OnPenUp(EventPtr event)
{
	Boolean hitted = false;
	UInt16 i;
	
	for (i=0; i<30 && !hitted; i++){
		if (CbxReleaseColorBox(&colorBox[i], event)){
			hitted = true;
			returnColorIndex = colorBox[i].color;
			
			FrmUpdateForm(frmPref, viewUpdateCode);
			closeForm();
			
			FrmReturnToForm(frmPref);
		}
	}
	
	return hitted;
}

static SECT1 Boolean frmSelectColor_OnPenDown(EventPtr event)
{
	UInt16 i;

	CbxReset();

	for (i=0; i<30; i++){
		CbxHitColorBox(&colorBox[i], event);
	}

	if (CbxIsSet()){
		return true;
	} else {
		return false;
	}
}

static SECT1 Boolean frmSelectColor_OnClose(EventPtr event)
{
	closeForm();
	return false;
}

static Boolean frmSelectColor_OnOpen(EventPtr event)
{
	RGBColorType color;
	UInt16 i, j, k, l;
	
	colorBox = MemPtrNew(sizeof(ColorBoxType) * 30);

	lastForm = modalForm;
	modalForm = FrmGetActiveForm();
	FrmDrawForm(modalForm);
	
	if (os35){
    	i=0;
    	for (j=0; j<3; j++){
    		for (k=0; k<3; k++){
    			for (l=0; l<3; l++){
    				color.r = j * 96;
    				color.g = k * 96;
    				color.b = l * 96;
    				CbxInitColorBox(&colorBox[i], ggtColor00 + i, WinRGBToIndex(&color));
    				i++;
    			}
    		}
    	}
    
    	color.r = 255;
    	color.g = 0;
    	color.b = 0;
    	CbxInitColorBox(&colorBox[i], ggtColor00 + i, WinRGBToIndex(&color));
    	i++;
    	
    	color.r = 0;
    	color.g = 255;
    	color.b = 0;
    	CbxInitColorBox(&colorBox[i], ggtColor00 + i, WinRGBToIndex(&color));
    	i++;
    
    	color.r = 0;
    	color.g = 0;
    	color.b = 255;
    	CbxInitColorBox(&colorBox[i], ggtColor00 + i, WinRGBToIndex(&color));
    	i++;
	}

	return true;
}

Boolean frmSelectColor_HandleEvent(EventPtr event)
{
	Boolean handled = false;

	switch (event->eType)
	{
		case penUpEvent:
			handled = frmSelectColor_OnPenUp(event);
			break;
		case penDownEvent:
			handled = frmSelectColor_OnPenDown(event);
			break;
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				case cmdClose:
					handled = frmSelectColor_cmdClose_OnSelect(event);
					break;
			}
			break;
		case frmCloseEvent:
			handled = frmSelectColor_OnClose(event);
			break;
		case frmOpenEvent:
			handled = frmSelectColor_OnOpen(event);
			break;
	}

	return handled;
}
