/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

typedef struct ReaderType {
	UInt16 version;
	UInt16 book;
	UInt16 chapter;
	UInt16 verse;

	UInt16 indexRecord;
	UInt16 totalRecord;

	UInt16 totalChapters;
	UInt16* totalVersesAcc;
	UInt32* totalChapterCharsAcc;
	UInt16* totalVerseCharsAcc;

	UInt32 verseStart;
	UInt16 verseLength;
	
	UInt16 bookmarkChapter;
	UInt16 bookmarkVerse;

	FullReaderType recordReader;
	DecoderType decoder;
} ReaderType;
typedef ReaderType *ReaderPtr;

// public functions

void RdrOpenReader(ReaderPtr reader);
void RdrCloseReader(ReaderPtr reader);

VersePtr RdrGetCurrentVerse(ReaderPtr reader);
Boolean RdrGetCurrentVerseAsString(ReaderPtr reader, char* verse);
void RdrMovePrevVerse(ReaderPtr reader);
void RdrMoveNextVerse(ReaderPtr reader);
Boolean RdrSeekVerse(ReaderPtr reader, UInt16 version, UInt16 book, UInt16 chapter, UInt16 verse);

void RdrBookmark(ReaderPtr reader);
void RdrReturn(ReaderPtr reader);
