/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"

static FullReaderPtr frdRecordReader;

void FrdOpenReader(FullReaderPtr recordReader, UInt16 version, UInt16 minRecord, UInt16 maxRecord)
{
	UInt16 totalRecord, i;
	
	recordReader->maxRecord = maxRecord;
	recordReader->minRecord = minRecord;

	totalRecord = recordReader->maxRecord - recordReader->minRecord + 1;

	recordReader->version = version;
}

void FrdCloseReader(FullReaderPtr recordReader)
{
}

void FrdReadBegin(FullReaderPtr recordReader, UInt32 start)
{
	recordReader->recordIndex = start / recordSize;
	recordReader->charIndex = start % recordSize;
	recordReader->recordPtr = DmxLockVersionRecord(recordReader->version, 
		recordReader->minRecord + recordReader->recordIndex);
}

void FrdReadEnd(FullReaderPtr recordReader)
{
	DmxUnlockVersionRecord(recordReader->version, 
		recordReader->minRecord + recordReader->recordIndex);
}

UInt8 FrdReadChar(FullReaderPtr recordReader)
{
	UInt16 recordIndex, charIndex;
	UInt8 resultChar;

	if (recordReader->charIndex >= recordSize){
		DmxUnlockVersionRecord(recordReader->version, 
			recordReader->minRecord + recordReader->recordIndex);
		recordReader->recordIndex++;
		recordReader->charIndex = 0;
		recordReader->recordPtr = DmxLockVersionRecord(recordReader->version, 
			recordReader->minRecord + recordReader->recordIndex);
	}
	resultChar = recordReader->recordPtr[recordReader->charIndex];
	recordReader->charIndex ++;

	return resultChar;
}

