/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

struct ViewerType;
typedef struct ViewerType *ViewerPtr;
typedef struct ViewerType {
	UInt16 version;
	UInt16 book;
	UInt16 chapter;
	UInt16 verse;
	UInt16 offset;
	
	RectangleType bound;

	UInt16 totalLines;
	
	Boolean enabled;
	Boolean rightAligned;

	VersePtr begin;
	ReaderType reader;
} ViewerType;

// public functions

void VwrOpenViewer(ViewerPtr viewer);
void VwrCloseViewer(ViewerPtr viewer);

void VwrScrollViewer(ViewerPtr viewer, WinDirectionType moveDir, Coord moveValue);
void VwrRelScrollViewer(ViewerPtr viewer, ViewerPtr relViewer);

void VwrRedrawViewer(ViewerPtr viewer);
void VwrRelRedrawViewer(ViewerPtr viewer, ViewerPtr relViewer);

